// g++ -O3 es.cc
// ****************************************************************

#include "./random_generators.h"
#include "./random_init.h"
#include "./es.h"

using namespace std;

// ****************************************************************

int main()
{ size_t parent_pop_size, offspring_pop_size, family_size, obj_dim;
  size_t max_number_of_generations;
  char obj_reco, strat_reco, selection_type, sel_type;
  double t_fak, stop_cond_sigma, sigma_init;

// ********************************************
  cout << "#                          mu = ";
  cin >> parent_pop_size;
  cout << "\n#                         rho = ";
  cin >> family_size;
  cout << "\n#                      lambda = ";
  cin >> offspring_pop_size;
  cout << "\n#  object param. reco type I|D: ";
  cin >> obj_reco;
  cout << "\n#    strat. par. reco type I|D: ";
  cin >> strat_reco;
  cout << "\n#      type of selection + | ,: ";
  cin >> selection_type;
  sel_type = (selection_type == '+' || selection_type == 'p') ? '+' : ',';
  cout << "\n#  prop. faktor t in learning" 
       << "\n#  rule parameter t/sqrt(n) t = ";
  cin >> t_fak;
  cout << "\n#            obj. param. dim. = ";
  cin >> obj_dim;
  cout << "\n#  max. number of generations = ";
  cin >> max_number_of_generations;
  cout << "\n#    stopping cond. for sigma < ";
  cin >> stop_cond_sigma;
  cout << "\n#               initial sigma = ";
  cin >> sigma_init;
  cout << "\n# " << endl;
// ********************************************

  vector<Individual> initial_parent_pop(parent_pop_size);
  vector<Individual> final_pop(parent_pop_size);
  Individual init_individual;

// initialize individual and population:
  vector<double> obj_init(obj_dim);
  for(size_t i=0; i < obj_dim; i++) 
    obj_init[i] = 100000*gaussINIT.SampleNormalZeroOne();
  double strat_init = sigma_init;
  init_individual.object_parameter = obj_init;
  init_individual.strategy_parameter = strat_init;
  init_individual.evaluate();
  for(size_t m=0; m < parent_pop_size; m++) 
    initial_parent_pop[m] = init_individual;
//
  final_pop = mu_rho_la_ES( initial_parent_pop, 
                            parent_pop_size, family_size, offspring_pop_size, 
                            obj_reco, strat_reco, sel_type,
                            t_fak/sqrt(double(obj_dim)), 
                            max_number_of_generations, stop_cond_sigma );
}
